local MAX_BIT_FLAGS_TUTORIAL = 4294934528;
local cvar_fields = {
	"shipyardMissionTutorialFirst",
	"shipyardMissionTutorialBlockade",
	"shipyardMissionTutorialAreaBuff",
	"lastVoidStorageTutorial",
};
local bit_fields = {
	LE_FRAME_TUTORIAL_ARTIFACT_APPEARANCE_TAB,
	LE_FRAME_TUTORIAL_ARTIFACT_KNOWLEDGE,
	LE_FRAME_TUTORIAL_ARTIFACT_RELIC_MATCH,
	LE_FRAME_TUTORIAL_BAG_SETTINGS,
	LE_FRAME_TUTORIAL_BONUS_ROLL_ENCOUNTER_JOURNAL_LINK,
	LE_FRAME_TUTORIAL_BOOSTED_SPELL_BOOK,
	LE_FRAME_TUTORIAL_BOUNTY_FINISHED,
	LE_FRAME_TUTORIAL_BOUNTY_INTRO,
	LE_FRAME_TUTORIAL_CLEAN_UP_BAGS,
	LE_FRAME_TUTORIAL_CORE_ABILITITES,
	LE_FRAME_TUTORIAL_FRIENDS_LIST_QUICK_JOIN,
	LE_FRAME_TUTORIAL_GAME_TIME_AUCTION_HOUSE,
	LE_FRAME_TUTORIAL_GARRISON_BUILDING,
	LE_FRAME_TUTORIAL_GARRISON_LANDING,
	LE_FRAME_TUTORIAL_GARRISON_ZONE_ABILITY,
	LE_FRAME_TUTORIAL_GLYPH,
	LE_FRAME_TUTORIAL_HEIRLOOM_JOURNAL,
	LE_FRAME_TUTORIAL_HEIRLOOM_JOURNAL_LEVEL,
	LE_FRAME_TUTORIAL_HEIRLOOM_JOURNAL_TAB,
	LE_FRAME_TUTORIAL_HONOR_TALENT_FIRST_TALENT,
	LE_FRAME_TUTORIAL_HONOR_TALENT_HONOR_LEVELS,
	LE_FRAME_TUTORIAL_HONOR_TALENT_PRESTIGE,
	LE_FRAME_TUTORIAL_IGNORE_QUEST,
	LE_FRAME_TUTORIAL_INVENTORY_FIXUP_CHECK_EXPANSION_LEGION,
	LE_FRAME_TUTORIAL_INVENTORY_FIXUP_EXPANSION_LEGION,
	LE_FRAME_TUTORIAL_LFG_LIST,
	LE_FRAME_TUTORIAL_PET_JOURNAL,
	LE_FRAME_TUTORIAL_PROFESSIONS,
	LE_FRAME_TUTORIAL_REAGENT_BANK_UNLOCK,
	LE_FRAME_TUTORIAL_REPUTATION_EXALTED_PLUS,
	LE_FRAME_TUTORIAL_SPEC,
	LE_FRAME_TUTORIAL_SPELLBOOK,
	LE_FRAME_TUTORIAL_TALENT,
	LE_FRAME_TUTORIAL_TOYBOX,
	LE_FRAME_TUTORIAL_TOYBOX_FAVORITE,
	LE_FRAME_TUTORIAL_TOYBOX_MOUSEWHEEL_PAGING,
	LE_FRAME_TUTORIAL_TRANSMOG_JOURNAL_TAB,
	LE_FRAME_TUTORIAL_TRANSMOG_MODEL_CLICK,
	LE_FRAME_TUTORIAL_TRANSMOG_OUTFIT_DROPDOWN,
	LE_FRAME_TUTORIAL_TRANSMOG_SPECS_BUTTON,
	LE_FRAME_TUTORIAL_VIEWABLE_ARTIFACT,
	LE_FRAME_TUTORIAL_WORLD_MAP_FRAME,
	LE_FRAME_TUTORIAL_WRAPPED_COLLECTION_ITEMS,
	LE_FRAME_TUTORIAL_X,
};

function TutorialBuster_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function TutorialBuster_OnEvent(self, event, ...)
	local arg1 = ...;
	if (event == "PLAYER_ENTERING_WORLD") then
		self:UnregisterEvent(event);

		if (not GetCVar("lastGarrisonMissionTutorial") or tonumber(GetCVar("lastGarrisonMissionTutorial")) < MAX_BIT_FLAGS_TUTORIAL) then
			SetCVar("lastGarrisonMissionTutorial", MAX_BIT_FLAGS_TUTORIAL);
		end
		if (not GetCVar("orderHallMissionTutorial") or tonumber(GetCVar("orderHallMissionTutorial")) < MAX_BIT_FLAGS_TUTORIAL) then
			SetCVar("orderHallMissionTutorial", MAX_BIT_FLAGS_TUTORIAL);
		end

		local _, field;
		for _,field in pairs(cvar_fields) do
			if (tonumber(GetCVar(field)) == 0) then
				SetCVar(field, 1);
			end
		end
		for _,field in pairs(bit_fields) do
			if (not GetCVarBitfield("closedInfoFrames", field)) then
				SetCVarBitfield("closedInfoFrames", field, true);
			end
		end
	end
end